##################################################################################################
##                                                                                              ##
##  Author: Justdabomb2                         <email: edngravy@sbcglobal.net>                 ##
##  Script: Request Script                                                                      ##
##  Version: v2.0                                                                               ##
##  Date: 10/26/2006                                                                            ##
##  Tested with: Eggdrop v1.6.18                                                                ##
##                                                                                              ##
##  Commands:     !request <nick> - Requests the nick to the channel the command was said on.   ##
##                !request <nick> <channel> - Requests the nick to specified channel.           ##
##                !request help - Shows the commands on the channel.                            ##
##                                                                                              ##
##                                                                                              ##
##  Installation:                                                                               ##
##                1. Save in your script directory as "request.tcl".                            ##
##                2. add line "source scripts/request.tcl to the bottom of your eggdrop         ##
##                   configuration file.                                                        ##
##                3. CTRL+F search for 'set requestownerofbot ' and change "YourNick" to your   ##
##                   nick.                                                                      ##
##   (optional) - 4. CTRL+F search for 'set requestbotmsgs' and change the messages below to    ##
##                   what you want it to say when a person requests your bot.                   ##
##   (optional) - 5. CTRL+F search for 'set requesttextcolor ' and change "1" to the color you  ##
##                   want to your bot use when the script is un use (use the color key below).  ##
##                6. Rehash or restart your bot, and type "!request help" in the channel.       ##
##                                                                                              ##
##                                                                                              ##
##  Bugs:         - None known yet, E-mail me if you find any.                                  ##
##                                                                                              ##
##                                                                                              ##
##  Features:     - You can turn the script on or off through a public command so that it does  ##
##                  not get over used.                                                          ##
##                  - Only the bot owner that you set in the global variable can use this       ##
##                    command.                                                                  ##
##                - If a nick is not specified it will notice the person who used the command   ##
##                  with the proper args to use.                                                ##
##                - If a channel is not specified it will request the specified nick to the     ##
##                  channel the command was used on.                                            ##
##                - You can easily set the color of the text you want it to use in a global     ##
##                  variable.                                                                   ##
##                - You can easily set random messages you want the bot to use when someone     ##
##                  requests the bot.                                                           ##
##                - You can set if you want the bot to kick a user when they request it or not. ##
##                - You can set the kick message through a global variable.                     ##
##                                                                                              ##
##                                                                                              ##
##  Color Key:                                                                                  ##
##                               ||=-------------=||=--------=||                                ##
##                               ||   Color Name  ||  Number  ||                                ##
##                               ||=-------------=||=--------=||                                ##
##                               || White         ||    0     ||                                ##
##                               || Black         ||    1     ||                                ##
##                               || Dark Blue     ||    2     ||                                ##
##                               || Green         ||    3     ||                                ##
##                               || Red           ||    4     ||                                ##
##                               || Brown         ||    5     ||                                ##
##                               || Purple        ||    6     ||                                ##
##                               || Orange        ||    7     ||                                ##
##                               || Yellow        ||    8     ||                                ##
##                               || Light Green   ||    9     ||                                ##
##                               || Teal          ||    10    ||                                ##
##                               || Light Blue    ||    11    ||                                ##
##                               || Blue          ||    12    ||                                ##
##                               || Pink          ||    13    ||                                ##
##                               || Dark Grey     ||    14    ||                                ##
##                               || Light Grey    ||    15    ||                                ##
##                               ||=-------------=||=--------=||                                ##
##                                                                                              ##
##                                                                                              ##
##  You do NOT need to change anything in this script (besides what it tells you to change in   ##
##             the installation), it should work the way it is right now.                       ##
##                                                                                              ##
##     Newer versions on this script will be if I decide something should be added or a bug     ##
##                                     needs to be fixed.                                       ##
##                                                                                              ##
##           If you notice any problems with the script, please e-mail them to me at            ##
##                                   edngravy@sbcglobal.net                                     ##
##                                                                                              ##
##                                                                                              ##
##  Please do not re-distribute a modified version of this script. If you do re-distribute      ##
##  it in it's original form, please give credit to me, and do not claim it as your own.        ##
##                                                                                              ##
##                                                                   ~Thank you!                ##
##                                                                                              ##
##################################################################################################

##############################################################
## You can set this different to change the color of text.  ##
##############################################################

set requesttextcolor "1"

#################################################################################
## You can set random messages your bot will use when a user requests the bot. ##
#################################################################################

set requestbotmsgs {
  "I am right here!"
  "Check your eyesight."
  "Are you stupid?"
  "Are you serious?"
}

####################################################################################
## Set this to the kick message you want the bot to use when someone requests it. ##
####################################################################################

set requestkickmsg "Wasting my time..."

######################################################################################
## This variable tells the bot to kick or not to kick the user when it is requested ##
######################################################################################
## Set it to 1 if you want the bot kick the user, and 0 if you don't. ##
########################################################################

set kickonbotrequest "1"

######################################################
## Do NOT forget to set this variable to your nick. ##
######################################################

set requestownerofbot "YourNick"

#######################################################
## You do not need to edit anything below this line. ##
#######################################################

#######################################################
##  Important variables, do not change them please.  ##
#######################################################

set requestonoroff 1
set requestcreator "Justdabomb2"
set requestsentmsg "Your request has been sent"
set requesthelpmsgone "Requests the nick to the channel the command was said on."
set requesthelpmsgtwo "Requests the nick to specified channel."
set requesthelpcmd "help"
set requestoncmd "on"
set requestoffcmd "off"

###########################
## This is the command.  ##
###########################

bind pub - !request pub:request

##############################################################################
## This is where the '!request <nick> <channel>' part of the script starts. ##
##############################################################################

proc pub:request {nick host handle chan arg} {
  global botnick requestbotmsgs kickonbotrequest requesthelpcmd requesttextcolor requestownerofbot requestonoroff
  global requestkickmsg requestsentmsg requesthelpmsgone requesthelpmsgtwo requestoncmd requestoffcmd
  set nicktorequest [lindex [split $arg] 0]
  if { $requestonoroff == 1 } {
    if {[string tolower $nicktorequest] == [string tolower $botnick]} {
      set requestbotmsg [lindex $requestbotmsgs [rand [llength $requestbotmsgs]]]
      if { $kickonbotrequest == 0 } {
        putquick "PRIVMSG $chan :\003requesttextcolor $requestbotmsg"
        return
      }
      if { $kickonbotrequest == 1 } {
        putquick "PRIVMSG $chan :\003$requesttextcolor $requestbotmsg"
        putquick "KICK $chan $nick :\003$requesttextcolor $requestkickmsg"
        return
      }
    }
    if {[string tolower $nicktorequest] == [string tolower $requesthelpcmd]} {
      putquick "PRIVMSG $chan :\003$requesttextcolor \002!request <nick> \002- $requesthelpmsgone"
      putquick "PRIVMSG $chan :\003$requesttextcolor \002!request <nick> <channel> \002- $requesthelpmsgtwo"
      return
    }
    if {[string tolower $nicktorequest] == [string tolower $requestoncmd]} {
      if {[string tolower $nick] == [string tolower $requestownerofbot]} {
        putquick "PRIVMSG $chan :\003$requesttextcolor Request has already been turned on."
        } else {
        putquick "PRIVMSG $chan :Only $requestownerofbot can use this command."
      }
      return
    }
    if {[string tolower $nicktorequest] == [string tolower $requestoffcmd]} {
      if {[string tolower $nick] == [string tolower $requestownerofbot]} {
        putquick "PRIVMSG $chan :\003$requesttextcolor Request has been turned off."
        set requestonoroff 0
        } else {
        putquick "PRIVMSG $chan :Only $requestownerofbot can use this command."
      }
      return
    }
    if {$nicktorequest == ""} {
      putquick "PRIVMSG $chan :\003$requesttextcolor Type \002!request <nick> <chan>\002"
      } else {
      set chanrequestto [lindex [split $arg] 1]
      if {$chanrequestto == ""} {
        putquick "NOTICE $nicktorequest :\003$requesttextcolor \002$nick wants you in $chan !\002"
        putquick "NOTICE $nick :\003$requesttextcolor \002$requestsentmsg to $nicktorequest.\002"
        } else {
        putquick "NOTICE $nicktorequest :\003$requesttextcolor \002$nick wants you in $chanrequestto !\002"
        putquick "NOTICE $nick :\003$requesttextcolor \002$requestsentmsg to $nicktorequest.\002"
      }
    }
  }
  if { $requestonoroff == 0 } {
    if {[string tolower $nicktorequest] == [string tolower $requestoncmd]} {
      if {[string tolower $nick] == [string tolower $requestownerofbot]} {
        putquick "PRIVMSG $chan :\003$requesttextcolor Request has been turned on."
        set requestonoroff 1
        } else {
        putquick "PRIVMSG $chan :Only $requestownerofbot can use this command."
      }
      return
    }
    if {[string tolower $nicktorequest] == [string tolower $requestoffcmd]} {
      if {[string tolower $nick] == [string tolower $requestownerofbot]} {
        putquick "PRIVMSG $chan :\003$requesttextcolor Request has already been turned off."
        } else {
        putquick "PRIVMSG $chan :Only $requestownerofbot can use this command."
      }
      return
    }
    if {$nicktorequest != ""} {
      putquick "PRIVMSG $chan :Request has been turned off."
      } else {
      putquick "PRIVMSG $chan :Request has been turned off."
    }
  }
}

putlog "$requestcreator's Request Script Loaded"